Index: src/Actions/GlobalListOfActions.hpp
===================================================================
--- src/Actions/GlobalListOfActions.hpp	(revision 91a5652e07406f1a37c1832e3a3c16579713f146)
+++ src/Actions/GlobalListOfActions.hpp	(revision 0b50574573487816f0c12002dfdc46008b5003c6)
@@ -125,5 +125,6 @@
   (ShapeCombineShapes) \
   (ShapeCreateShape) \
-  (ShapeRemoveShape)
+  (ShapeRemoveShape) \
+  (ShapeTranslateShape)
 
 // we need to append the automation action in case we have the JobMarket
Index: src/Actions/Makefile.am
===================================================================
--- src/Actions/Makefile.am	(revision 91a5652e07406f1a37c1832e3a3c16579713f146)
+++ src/Actions/Makefile.am	(revision 0b50574573487816f0c12002dfdc46008b5003c6)
@@ -434,13 +434,16 @@
   Actions/ShapeAction/CombineShapesAction.cpp \
   Actions/ShapeAction/CreateShapeAction.cpp \
-  Actions/ShapeAction/RemoveShapeAction.cpp
+  Actions/ShapeAction/RemoveShapeAction.cpp \
+  Actions/ShapeAction/TranslateShapeAction.cpp
 SHAPEACTIONHEADER = \
   Actions/ShapeAction/CombineShapesAction.hpp \
   Actions/ShapeAction/CreateShapeAction.hpp \
-  Actions/ShapeAction/RemoveShapeAction.hpp
+  Actions/ShapeAction/RemoveShapeAction.hpp \
+  Actions/ShapeAction/TranslateShapeAction.hpp
 SHAPEACTIONDEFS = \
   Actions/ShapeAction/CombineShapesAction.def \
   Actions/ShapeAction/CreateShapeAction.def \
-  Actions/ShapeAction/RemoveShapeAction.def
+  Actions/ShapeAction/RemoveShapeAction.def \
+  Actions/ShapeAction/TranslateShapeAction.def
 	
 TESSELATIONACTIONSOURCE = \
Index: src/Actions/ShapeAction/TranslateShapeAction.cpp
===================================================================
--- src/Actions/ShapeAction/TranslateShapeAction.cpp	(revision 0b50574573487816f0c12002dfdc46008b5003c6)
+++ src/Actions/ShapeAction/TranslateShapeAction.cpp	(revision 0b50574573487816f0c12002dfdc46008b5003c6)
@@ -0,0 +1,110 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
+ *
+ *
+ *   This file is part of MoleCuilder.
+ *
+ *    MoleCuilder is free software: you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation, either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    MoleCuilder is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/*
+ * TranslateShapeAction.cpp
+ *
+ *  Created on: Nov 19, 2012
+ *      Author: ankele
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "Shapes/ShapeRegistry.hpp"
+#include "Shapes/ShapeOps.hpp"
+#include "CodePatterns/Log.hpp"
+#include "CodePatterns/Verbose.hpp"
+
+#include <iostream>
+#include <string>
+
+#include "TranslateShapeAction.hpp"
+
+using namespace MoleCuilder;
+
+// and construct the stuff
+#include "TranslateShapeAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr ShapeTranslateShapeAction::performCall() {
+  LOG(1, "Translating shapes in ShapeRegistry.");
+
+  std::vector<Shape> old_shapes;
+
+  std::vector<Shape*> selectedShapes = ShapeRegistry::getInstance().getSelectedShapes();
+
+  for (unsigned int i=0;i<selectedShapes.size();i++){
+    old_shapes.push_back(*selectedShapes[i]);
+    Shape s = translate(*selectedShapes[i], params.translation.get());
+    std::string name = selectedShapes[i]->getName();
+    s.setName(name);
+    ShapeRegistry::getInstance().removeShape(name);
+    ShapeRegistry::getInstance().addShape(s);
+    ShapeRegistry::getInstance().selectShape(name);
+  }
+
+  return Action::state_ptr(new ShapeTranslateShapeState(old_shapes, params));
+}
+
+Action::state_ptr ShapeTranslateShapeAction::performUndo(Action::state_ptr _state) {
+  ShapeTranslateShapeState *state = assert_cast<ShapeTranslateShapeState*>(_state.get());
+
+  for (unsigned int i=0;i<state->old_shapes.size();i++){
+    std::string name = state->old_shapes[i].getName();
+    ShapeRegistry::getInstance().removeShape(name);
+    ShapeRegistry::getInstance().addShape(state->old_shapes[i]);
+    ShapeRegistry::getInstance().selectShape(name);
+  }
+
+  return Action::state_ptr(_state);
+}
+
+Action::state_ptr ShapeTranslateShapeAction::performRedo(Action::state_ptr _state){
+  ShapeTranslateShapeState *state = assert_cast<ShapeTranslateShapeState*>(_state.get());
+
+  std::vector<Shape*> selectedShapes = ShapeRegistry::getInstance().getSelectedShapes();
+
+  for (unsigned int i=0;i<selectedShapes.size();i++){
+    Shape s = translate(*selectedShapes[i], state->params.translation.get());
+    std::string name = selectedShapes[i]->getName();
+    s.setName(name);
+    ShapeRegistry::getInstance().removeShape(name);
+    ShapeRegistry::getInstance().addShape(s);
+    ShapeRegistry::getInstance().selectShape(name);
+  }
+
+  return Action::state_ptr(_state);
+}
+
+bool ShapeTranslateShapeAction::canUndo() {
+  return true;
+}
+
+bool ShapeTranslateShapeAction::shouldUndo() {
+  return true;
+}
+/** =========== end of function ====================== */
Index: src/Actions/ShapeAction/TranslateShapeAction.def
===================================================================
--- src/Actions/ShapeAction/TranslateShapeAction.def	(revision 0b50574573487816f0c12002dfdc46008b5003c6)
+++ src/Actions/ShapeAction/TranslateShapeAction.def	(revision 0b50574573487816f0c12002dfdc46008b5003c6)
@@ -0,0 +1,38 @@
+/*
+ * TranslateShapeAction.def
+ *
+ *  Created on: Nov 19, 2012
+ *      Author: ankele
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+#include <boost/filesystem.hpp>
+
+#include "Parameters/Validators/DummyValidator.hpp"
+class Shape;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+#define paramtypes (Vector)
+#define paramtokens ("translate-shapes")
+#define paramdescriptions ("translation distance")
+#define paramdefaults (PARAM_DEFAULT(Vector(0.,0.,0.)))
+#define paramreferences (translation)
+#define paramvalids \
+(DummyValidator<Vector>())
+
+#define statetypes (std::vector<Shape>)
+#define statereferences (old_shapes)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Shape
+#define MENUNAME "shape"
+#define MENUPOSITION 4
+#define ACTIONNAME TranslateShape
+#define TOKEN "translate-shapes"
+
+
+// finally the information stored in the ActionTrait specialization
+#define DESCRIPTION "moves selected shapes in ShapeRegistry"
+#undef SHORTFORM
Index: src/Actions/ShapeAction/TranslateShapeAction.hpp
===================================================================
--- src/Actions/ShapeAction/TranslateShapeAction.hpp	(revision 0b50574573487816f0c12002dfdc46008b5003c6)
+++ src/Actions/ShapeAction/TranslateShapeAction.hpp	(revision 0b50574573487816f0c12002dfdc46008b5003c6)
@@ -0,0 +1,22 @@
+/*
+ * TranslateShapeAction.hpp
+ *
+ *  Created on: Nov 19, 2012
+ *      Author: ankele
+ */
+
+#ifndef TRANSLATESHAPEACTION_HPP_
+#define TRANSLATESHAPEACTION_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include "Actions/Action.hpp"
+
+#include "TranslateShapeAction.def"
+#include "Action_impl_header.hpp"
+
+#endif /* TRANSLATESHAPEACTION_HPP_ */
